Index: /palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- /palm/trunk/SOURCE/advec_ws.f90	(revision 3550)
+++ /palm/trunk/SOURCE/advec_ws.f90	(revision 3551)
@@ -25,4 +25,12 @@
 ! -----------------
 ! $Id$
+! - Computation of vertical fluxes separated from computation of horizontal 
+!   fluxes. Loops are splitted in order to avoid indirect indexing and allow 
+!   for better vectorization. 
+! - Accelerate code by remove type-conversions of ibits
+! - replace pointer definition in scalar routine by simple explicit definition
+!   of the passed array
+! 
+! 3547 2018-11-21 13:21:24Z suehring
 ! variables documented
 ! 
@@ -193,5 +201,5 @@
 !
 ! 888 2012-04-20 15:03:46Z suehring
-! Number of IBITS() calls with identical arguments is reduced.
+! Number of REAL( IBITS() calls with identical arguments is reduced.
 !
 ! 862 2012-03-26 14:21:38Z suehring
@@ -1200,13 +1208,4 @@
        
        INTEGER(iwp) ::  i     !< grid index along x-direction
-       INTEGER(iwp) ::  ibit0 !< flag indicating 1st-order scheme along x-direction
-       INTEGER(iwp) ::  ibit1 !< flag indicating 3rd-order scheme along x-direction
-       INTEGER(iwp) ::  ibit2 !< flag indicating 5th-order scheme along x-direction
-       INTEGER(iwp) ::  ibit3 !< flag indicating 1st-order scheme along y-direction
-       INTEGER(iwp) ::  ibit4 !< flag indicating 3rd-order scheme along y-direction
-       INTEGER(iwp) ::  ibit5 !< flag indicating 5th-order scheme along y-direction
-       INTEGER(iwp) ::  ibit6 !< flag indicating 1st-order scheme along z-direction
-       INTEGER(iwp) ::  ibit7 !< flag indicating 3rd-order scheme along z-direction
-       INTEGER(iwp) ::  ibit8 !< flag indicating 5th-order scheme along z-direction
        INTEGER(iwp) ::  i_omp !< leftmost index on subdomain, or in case of OpenMP, on thread
        INTEGER(iwp) ::  j     !< grid index along y-direction
@@ -1217,4 +1216,13 @@
        INTEGER(iwp) ::  tn    !< number of OpenMP thread
        
+       REAL(wp)     ::  ibit0  !< flag indicating 1st-order scheme along x-direction
+       REAL(wp)     ::  ibit1  !< flag indicating 3rd-order scheme along x-direction
+       REAL(wp)     ::  ibit2  !< flag indicating 5th-order scheme along x-direction
+       REAL(wp)     ::  ibit3  !< flag indicating 1st-order scheme along y-direction
+       REAL(wp)     ::  ibit4  !< flag indicating 3rd-order scheme along y-direction
+       REAL(wp)     ::  ibit5  !< flag indicating 5th-order scheme along y-direction
+       REAL(wp)     ::  ibit6  !< flag indicating 1st-order scheme along z-direction
+       REAL(wp)     ::  ibit7  !< flag indicating 3rd-order scheme along z-direction
+       REAL(wp)     ::  ibit8  !< flag indicating 5th-order scheme along z-direction
        REAL(wp)     ::  diss_d !< artificial dissipation term at grid box bottom
        REAL(wp)     ::  div    !< diverence on scalar grid
@@ -1222,10 +1230,12 @@
        REAL(wp)     ::  u_comp !< advection velocity along x-direction 
        REAL(wp)     ::  v_comp !< advection velocity along y-direction 
-       
-#if defined( __nopointer )
-       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  sk !< advected scalar
-#else
-       REAL(wp), DIMENSION(:,:,:), POINTER    ::  sk     !< advected scalar
-#endif
+!       
+!--    sk is an array from parameter list. It should not be a pointer, because 
+!--    in that case the compiler can not assume a stride 1 and cannot perform 
+!--    a strided one vector load. Adding the CONTIGUOUS keyword makes things 
+!--    even worse, because the compiler cannot assume strided one in the 
+!--    caller side.
+       REAL(wp), INTENT(IN),DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  sk !<  advected scalar
+
        REAL(wp), DIMENSION(nzb:nzt+1)         ::  diss_n !< discretized artificial dissipation at northward-side of the grid box
        REAL(wp), DIMENSION(nzb:nzt+1)         ::  diss_r !< discretized artificial dissipation at rightward-side of the grid box
@@ -1249,7 +1259,7 @@
           DO  k = nzb+1, nzb_max
 
-             ibit5 = IBITS(advc_flags_1(k,j-1,i),5,1)
-             ibit4 = IBITS(advc_flags_1(k,j-1,i),4,1)
-             ibit3 = IBITS(advc_flags_1(k,j-1,i),3,1)
+             ibit5 = REAL( IBITS(advc_flags_1(k,j-1,i),5,1), KIND = wp )
+             ibit4 = REAL( IBITS(advc_flags_1(k,j-1,i),4,1), KIND = wp )
+             ibit3 = REAL( IBITS(advc_flags_1(k,j-1,i),3,1), KIND = wp )
 
              v_comp                  = v(k,j,i) - v_gtrans + v_stokes_zu(k)
@@ -1310,7 +1320,7 @@
           DO  k = nzb+1, nzb_max
 
-             ibit2 = IBITS(advc_flags_1(k,j,i-1),2,1)
-             ibit1 = IBITS(advc_flags_1(k,j,i-1),1,1)
-             ibit0 = IBITS(advc_flags_1(k,j,i-1),0,1)
+             ibit2 = REAL( IBITS(advc_flags_1(k,j,i-1),2,1), KIND = wp )
+             ibit1 = REAL( IBITS(advc_flags_1(k,j,i-1),1,1), KIND = wp )
+             ibit0 = REAL( IBITS(advc_flags_1(k,j,i-1),0,1), KIND = wp )
 
              u_comp                     = u(k,j,i) - u_gtrans + u_stokes_zu(k)
@@ -1365,7 +1375,4 @@
            
        ENDIF
-
-       flux_t(0) = 0.0_wp
-       diss_t(0) = 0.0_wp
 !        
 !--    Now compute the fluxes and tendency terms for the horizontal and
@@ -1377,7 +1384,7 @@
 !--       flux at the end. 
 
-          ibit2 = IBITS(advc_flags_1(k,j,i),2,1)
-          ibit1 = IBITS(advc_flags_1(k,j,i),1,1)
-          ibit0 = IBITS(advc_flags_1(k,j,i),0,1)
+          ibit2 = REAL( IBITS(advc_flags_1(k,j,i),2,1), KIND = wp )
+          ibit1 = REAL( IBITS(advc_flags_1(k,j,i),1,1), KIND = wp )
+          ibit0 = REAL( IBITS(advc_flags_1(k,j,i),0,1), KIND = wp )
 
           u_comp    = u(k,j,i+1) - u_gtrans + u_stokes_zu(k)
@@ -1412,7 +1419,7 @@
                                        )
 
-          ibit5 = IBITS(advc_flags_1(k,j,i),5,1)
-          ibit4 = IBITS(advc_flags_1(k,j,i),4,1)
-          ibit3 = IBITS(advc_flags_1(k,j,i),3,1)
+          ibit5 = REAL( IBITS(advc_flags_1(k,j,i),5,1), KIND = wp )
+          ibit4 = REAL( IBITS(advc_flags_1(k,j,i),4,1), KIND = wp )
+          ibit3 = REAL( IBITS(advc_flags_1(k,j,i),3,1), KIND = wp )
 
           v_comp    = v(k,j+1,i) - v_gtrans + v_stokes_zu(k)
@@ -1446,91 +1453,4 @@
                              ( sk(k,j+3,i) - sk(k,j-2,i) )                    &
                                        )
-!
-!--       k index has to be modified near bottom and top, else array
-!--       subscripts will be exceeded.
-          ibit8 = IBITS(advc_flags_1(k,j,i),8,1)
-          ibit7 = IBITS(advc_flags_1(k,j,i),7,1)
-          ibit6 = IBITS(advc_flags_1(k,j,i),6,1)
-
-          k_ppp = k + 3 * ibit8
-          k_pp  = k + 2 * ( 1 - ibit6  )
-          k_mm  = k - 2 * ibit8
-
-
-          flux_t(k) = w(k,j,i) * rho_air_zw(k) * (                            &
-                     ( 37.0_wp * ibit8 * adv_sca_5                            &
-                  +     7.0_wp * ibit7 * adv_sca_3                            &
-                  +              ibit6 * adv_sca_1                            &
-                     ) *                                                      &
-                             ( sk(k+1,j,i)  + sk(k,j,i)    )                  &
-              -      (  8.0_wp * ibit8 * adv_sca_5                            &
-                  +              ibit7 * adv_sca_3                            &
-                     ) *                                                      &
-                             ( sk(k_pp,j,i) + sk(k-1,j,i)  )                  &
-              +      (           ibit8 * adv_sca_5                            &
-                     ) *     ( sk(k_ppp,j,i)+ sk(k_mm,j,i) )                  &
-                                 )
-
-          diss_t(k) = -ABS( w(k,j,i) ) * rho_air_zw(k) * (                    &
-                     ( 10.0_wp * ibit8 * adv_sca_5                            &
-                  +     3.0_wp * ibit7 * adv_sca_3                            &
-                  +              ibit6 * adv_sca_1                            &
-                     ) *                                                      &
-                             ( sk(k+1,j,i)   - sk(k,j,i)    )                 &
-              -      (  5.0_wp * ibit8 * adv_sca_5                            &
-                  +              ibit7 * adv_sca_3                            &
-                     ) *                                                      &
-                             ( sk(k_pp,j,i)  - sk(k-1,j,i)  )                 &
-              +      (           ibit8 * adv_sca_5                            &
-                     ) *                                                      &
-                             ( sk(k_ppp,j,i) - sk(k_mm,j,i) )                 &
-                                         )
-       ENDDO
-
-       DO  k = nzb+1, nzb_max
-
-          flux_d    = flux_t(k-1)
-          diss_d    = diss_t(k-1)
-!
-!--       Calculate the divergence of the velocity field. A respective
-!--       correction is needed to overcome numerical instabilities caused
-!--       by a not sufficient reduction of divergences near topography. 
-          div         =   ( u(k,j,i+1) * ( ibit0 + ibit1 + ibit2 )             &
-                          - u(k,j,i)   * ( IBITS(advc_flags_1(k,j,i-1),0,1)    &
-                                         + IBITS(advc_flags_1(k,j,i-1),1,1)    &
-                                         + IBITS(advc_flags_1(k,j,i-1),2,1)    &
-                                         )                                     &
-                          ) * ddx                                              &
-                        + ( v(k,j+1,i) * ( ibit3 + ibit4 + ibit5 )             &
-                          - v(k,j,i)   * ( IBITS(advc_flags_1(k,j-1,i),3,1)    &
-                                         + IBITS(advc_flags_1(k,j-1,i),4,1)    &
-                                         + IBITS(advc_flags_1(k,j-1,i),5,1)    &
-                                         )                                     &
-                          ) * ddy                                              &
-                        + ( w(k,j,i) * rho_air_zw(k) *                         &
-                                         ( ibit6 + ibit7 + ibit8 )             &
-                          - w(k-1,j,i) * rho_air_zw(k-1) *                     &
-                                         ( IBITS(advc_flags_1(k-1,j,i),6,1)    &
-                                         + IBITS(advc_flags_1(k-1,j,i),7,1)    &
-                                         + IBITS(advc_flags_1(k-1,j,i),8,1)    &
-                                         )                                     &      
-                          ) * drho_air(k) * ddzw(k)
-
-
-          tend(k,j,i) = tend(k,j,i) - (                                       &
-                        ( flux_r(k) + diss_r(k) - swap_flux_x_local(k,j,tn) - &
-                          swap_diss_x_local(k,j,tn)            ) * ddx        &
-                      + ( flux_n(k) + diss_n(k) - swap_flux_y_local(k,tn)   - &
-                          swap_diss_y_local(k,tn)              ) * ddy        &
-                      + ( ( flux_t(k) + diss_t(k) ) -                         &
-                          ( flux_d    + diss_d    )                           &
-                                                    ) * drho_air(k) * ddzw(k) &
-                                      ) + sk(k,j,i) * div
-
-          swap_flux_y_local(k,tn)   = flux_n(k)
-          swap_diss_y_local(k,tn)   = diss_n(k)
-          swap_flux_x_local(k,j,tn) = flux_r(k)
-          swap_diss_x_local(k,j,tn) = diss_r(k)
-
        ENDDO
 !
@@ -1559,47 +1479,137 @@
                     -  5.0_wp * ( sk(k,j+2,i) - sk(k,j-1,i) )                 &
                     +           ( sk(k,j+3,i) - sk(k,j-2,i) ) ) * adv_sca_5
+
+       ENDDO
+!
+!--    Now, compute vertical fluxes. Split loop into a part treating the 
+!--    lowest 2 grid points with indirect indexing, a main loop without
+!--    indirect indexing, and a loop for the uppermost 2 grip points with
+!--    indirect indexing. This allows better vectorization for the main loop.
+!--    First, compute the flux at model surface, which need has to be 
+!--    calculated explicetely for the tendency at
+!--    the first w-level. For topography wall this is done implicitely by
+!--    advc_flags_1.
+       flux_t(nzb) = 0.0_wp
+       diss_t(nzb) = 0.0_wp
+       DO  k = nzb+1, nzb+2
+          ibit8 = REAL( IBITS(advc_flags_1(k,j,i),8,1), KIND = wp )
+          ibit7 = REAL( IBITS(advc_flags_1(k,j,i),7,1), KIND = wp )
+          ibit6 = REAL( IBITS(advc_flags_1(k,j,i),6,1), KIND = wp )
 !
 !--       k index has to be modified near bottom and top, else array
 !--       subscripts will be exceeded.
-          ibit8 = IBITS(advc_flags_1(k,j,i),8,1)
-          ibit7 = IBITS(advc_flags_1(k,j,i),7,1)
-          ibit6 = IBITS(advc_flags_1(k,j,i),6,1)
-
           k_ppp = k + 3 * ibit8
           k_pp  = k + 2 * ( 1 - ibit6  )
           k_mm  = k - 2 * ibit8
 
+
           flux_t(k) = w(k,j,i) * rho_air_zw(k) * (                            &
-                    ( 37.0_wp * ibit8 * adv_sca_5                             &
-                 +     7.0_wp * ibit7 * adv_sca_3                             &
-                 +              ibit6 * adv_sca_1                             &
-                    ) *                                                       &
-                             ( sk(k+1,j,i)  + sk(k,j,i)   )                   &
-              -     (  8.0_wp * ibit8 * adv_sca_5                             &
+                     ( 37.0_wp * ibit8 * adv_sca_5                            &
+                  +     7.0_wp * ibit7 * adv_sca_3                            &
+                  +              ibit6 * adv_sca_1                            &
+                     ) *                                                      &
+                             ( sk(k+1,j,i)  + sk(k,j,i)    )                  &
+              -      (  8.0_wp * ibit8 * adv_sca_5                            &
                   +              ibit7 * adv_sca_3                            &
-                    ) *                                                       &
-                             ( sk(k_pp,j,i) + sk(k-1,j,i) )                   &
-              +     (           ibit8 * adv_sca_5                             &
-                    ) *     ( sk(k_ppp,j,i)+ sk(k_mm,j,i) )                   &
+                     ) *                                                      &
+                             ( sk(k_pp,j,i) + sk(k-1,j,i)  )                  &
+              +      (           ibit8 * adv_sca_5                            &
+                     ) *     ( sk(k_ppp,j,i)+ sk(k_mm,j,i) )                  &
                                  )
 
           diss_t(k) = -ABS( w(k,j,i) ) * rho_air_zw(k) * (                    &
-                    ( 10.0_wp * ibit8 * adv_sca_5                             &
-                 +     3.0_wp * ibit7 * adv_sca_3                             &
-                 +              ibit6 * adv_sca_1                             &
-                    ) *                                                       &
+                     ( 10.0_wp * ibit8 * adv_sca_5                            &
+                  +     3.0_wp * ibit7 * adv_sca_3                            &
+                  +              ibit6 * adv_sca_1                            &
+                     ) *                                                      &
                              ( sk(k+1,j,i)   - sk(k,j,i)    )                 &
-              -     (  5.0_wp * ibit8 * adv_sca_5                             &
-                 +              ibit7 * adv_sca_3                             &
-                    ) *                                                       &
+              -      (  5.0_wp * ibit8 * adv_sca_5                            &
+                  +              ibit7 * adv_sca_3                            &
+                     ) *                                                      &
                              ( sk(k_pp,j,i)  - sk(k-1,j,i)  )                 &
-              +     (           ibit8 * adv_sca_5                             &
-                    ) *                                                       &
+              +      (           ibit8 * adv_sca_5                            &
+                     ) *                                                      &
                              ( sk(k_ppp,j,i) - sk(k_mm,j,i) )                 &
                                          )
-
-       ENDDO
-
-       DO  k = nzb_max+1, nzt
+       ENDDO 
+       
+       DO  k = nzb+3, nzt-2
+          ibit8 = REAL( IBITS(advc_flags_1(k,j,i),8,1), KIND = wp )
+          ibit7 = REAL( IBITS(advc_flags_1(k,j,i),7,1), KIND = wp )
+          ibit6 = REAL( IBITS(advc_flags_1(k,j,i),6,1), KIND = wp )
+
+          flux_t(k) = w(k,j,i) * rho_air_zw(k) * (                            &
+                     ( 37.0_wp * ibit8 * adv_sca_5                            &
+                  +     7.0_wp * ibit7 * adv_sca_3                            &
+                  +              ibit6 * adv_sca_1                            &
+                     ) *                                                      &
+                             ( sk(k+1,j,i)  + sk(k,j,i)    )                  &
+              -      (  8.0_wp * ibit8 * adv_sca_5                            &
+                  +              ibit7 * adv_sca_3                            &
+                     ) *                                                      &
+                             ( sk(k+2,j,i) + sk(k-1,j,i)  )                   &
+              +      (           ibit8 * adv_sca_5                            &
+                     ) *     ( sk(k+3,j,i)+ sk(k-2,j,i) )                     &
+                                                 )
+
+          diss_t(k) = -ABS( w(k,j,i) ) * rho_air_zw(k) * (                    &
+                     ( 10.0_wp * ibit8 * adv_sca_5                            &
+                  +     3.0_wp * ibit7 * adv_sca_3                            &
+                  +              ibit6 * adv_sca_1                            &
+                     ) *                                                      &
+                             ( sk(k+1,j,i)   - sk(k,j,i)    )                 &
+              -      (  5.0_wp * ibit8 * adv_sca_5                            &
+                  +              ibit7 * adv_sca_3                            &
+                     ) *                                                      &
+                             ( sk(k+2,j,i)  - sk(k-1,j,i)  )                  &
+              +      (           ibit8 * adv_sca_5                            &
+                     ) *                                                      &
+                             ( sk(k+3,j,i) - sk(k-2,j,i) )                    &
+                                                         )
+       ENDDO       
+       
+       DO  k = nzt-1, nzt
+          ibit8 = REAL( IBITS(advc_flags_1(k,j,i),8,1), KIND = wp )
+          ibit7 = REAL( IBITS(advc_flags_1(k,j,i),7,1), KIND = wp )
+          ibit6 = REAL( IBITS(advc_flags_1(k,j,i),6,1), KIND = wp )
+!
+!--       k index has to be modified near bottom and top, else array
+!--       subscripts will be exceeded.
+          k_ppp = k + 3 * ibit8
+          k_pp  = k + 2 * ( 1 - ibit6  )
+          k_mm  = k - 2 * ibit8
+
+
+          flux_t(k) = w(k,j,i) * rho_air_zw(k) * (                            &
+                     ( 37.0_wp * ibit8 * adv_sca_5                            &
+                  +     7.0_wp * ibit7 * adv_sca_3                            &
+                  +              ibit6 * adv_sca_1                            &
+                     ) *                                                      &
+                             ( sk(k+1,j,i)  + sk(k,j,i)    )                  &
+              -      (  8.0_wp * ibit8 * adv_sca_5                            &
+                  +              ibit7 * adv_sca_3                            &
+                     ) *                                                      &
+                             ( sk(k_pp,j,i) + sk(k-1,j,i)  )                  &
+              +      (           ibit8 * adv_sca_5                            &
+                     ) *     ( sk(k_ppp,j,i)+ sk(k_mm,j,i) )                  &
+                                                 )
+
+          diss_t(k) = -ABS( w(k,j,i) ) * rho_air_zw(k) * (                    &
+                     ( 10.0_wp * ibit8 * adv_sca_5                            &
+                  +     3.0_wp * ibit7 * adv_sca_3                            &
+                  +              ibit6 * adv_sca_1                            &
+                     ) *                                                      &
+                             ( sk(k+1,j,i)   - sk(k,j,i)    )                 &
+              -      (  5.0_wp * ibit8 * adv_sca_5                            &
+                  +              ibit7 * adv_sca_3                            &
+                     ) *                                                      &
+                             ( sk(k_pp,j,i)  - sk(k-1,j,i)  )                 &
+              +      (           ibit8 * adv_sca_5                            &
+                     ) *                                                      &
+                             ( sk(k_ppp,j,i) - sk(k_mm,j,i) )                 &
+                                                         )
+       ENDDO 
+
+       DO  k = nzb+1, nzt
 
           flux_d    = flux_t(k-1)
@@ -1610,8 +1620,26 @@
 !--       correction is needed to overcome numerical instabilities introduced
 !--       by a not sufficient reduction of divergences near topography.
-          div         =   ( u(k,j,i+1) - u(k,j,i)   ) * ddx                   &
-                        + ( v(k,j+1,i) - v(k,j,i)   ) * ddy                   &
-                        + ( w(k,j,i)   * rho_air_zw(k) -                      &
-                            w(k-1,j,i) * rho_air_zw(k-1)                      &
+          div         =   ( u(k,j,i+1) * ( ibit0 + ibit1 + ibit2 )            &
+                          - u(k,j,i)   * (                                    &
+                        REAL( IBITS(advc_flags_1(k,j,i-1),0,1), KIND = wp )   &
+                      + REAL( IBITS(advc_flags_1(k,j,i-1),1,1), KIND = wp )   &
+                      + REAL( IBITS(advc_flags_1(k,j,i-1),2,1), KIND = wp )   &
+                                         )                                    &
+                          ) * ddx                                             &
+                        + ( v(k,j+1,i) * ( ibit3 + ibit4 + ibit5 )            &
+                          - v(k,j,i)   * (                                    &
+                        REAL( IBITS(advc_flags_1(k,j-1,i),3,1), KIND = wp )   &
+                      + REAL( IBITS(advc_flags_1(k,j-1,i),4,1), KIND = wp )   &
+                      + REAL( IBITS(advc_flags_1(k,j-1,i),5,1), KIND = wp )   &
+                                         )                                    &
+                          ) * ddy                                             &
+                        + ( w(k,j,i) * rho_air_zw(k) *                        &
+                                         ( ibit6 + ibit7 + ibit8 )            &
+                          - w(k-1,j,i) * rho_air_zw(k-1) *                    &
+                                         (                                    &
+                        REAL( IBITS(advc_flags_1(k-1,j,i),6,1), KIND = wp )   &
+                      + REAL( IBITS(advc_flags_1(k-1,j,i),7,1), KIND = wp )   &
+                      + REAL( IBITS(advc_flags_1(k-1,j,i),8,1), KIND = wp )   &
+                                         )                                    &      
                           ) * drho_air(k) * ddzw(k)
 
@@ -1777,13 +1805,4 @@
 
        INTEGER(iwp) ::  i      !< grid index along x-direction
-       INTEGER(iwp) ::  ibit9  !< flag indicating 1st-order scheme along x-direction
-       INTEGER(iwp) ::  ibit10 !< flag indicating 3rd-order scheme along x-direction
-       INTEGER(iwp) ::  ibit11 !< flag indicating 5th-order scheme along x-direction
-       INTEGER(iwp) ::  ibit12 !< flag indicating 1st-order scheme along y-direction
-       INTEGER(iwp) ::  ibit13 !< flag indicating 3rd-order scheme along y-direction
-       INTEGER(iwp) ::  ibit14 !< flag indicating 5th-order scheme along y-direction
-       INTEGER(iwp) ::  ibit15 !< flag indicating 1st-order scheme along z-direction
-       INTEGER(iwp) ::  ibit16 !< flag indicating 3rd-order scheme along z-direction
-       INTEGER(iwp) ::  ibit17 !< flag indicating 5th-order scheme along z-direction
        INTEGER(iwp) ::  i_omp  !< leftmost index on subdomain, or in case of OpenMP, on thread
        INTEGER(iwp) ::  j      !< grid index along y-direction
@@ -1794,4 +1813,13 @@
        INTEGER(iwp) ::  tn     !< number of OpenMP thread
        
+       REAL(wp)    ::  ibit9    !< flag indicating 1st-order scheme along x-direction
+       REAL(wp)    ::  ibit10   !< flag indicating 3rd-order scheme along x-direction
+       REAL(wp)    ::  ibit11   !< flag indicating 5th-order scheme along x-direction
+       REAL(wp)    ::  ibit12   !< flag indicating 1st-order scheme along y-direction
+       REAL(wp)    ::  ibit13   !< flag indicating 3rd-order scheme along y-direction
+       REAL(wp)    ::  ibit14   !< flag indicating 5th-order scheme along y-direction
+       REAL(wp)    ::  ibit15   !< flag indicating 1st-order scheme along z-direction
+       REAL(wp)    ::  ibit16   !< flag indicating 3rd-order scheme along z-direction
+       REAL(wp)    ::  ibit17   !< flag indicating 5th-order scheme along z-direction
        REAL(wp)    ::  diss_d   !< artificial dissipation term at grid box bottom
        REAL(wp)    ::  div      !< diverence on u-grid
@@ -1819,7 +1847,7 @@
           DO  k = nzb+1, nzb_max
 
-             ibit14 = IBITS(advc_flags_1(k,j-1,i),14,1)
-             ibit13 = IBITS(advc_flags_1(k,j-1,i),13,1)
-             ibit12 = IBITS(advc_flags_1(k,j-1,i),12,1)
+             ibit14 = REAL( IBITS(advc_flags_1(k,j-1,i),14,1), KIND = wp )
+             ibit13 = REAL( IBITS(advc_flags_1(k,j-1,i),13,1), KIND = wp )
+             ibit12 = REAL( IBITS(advc_flags_1(k,j-1,i),12,1), KIND = wp )
 
              v_comp(k)      = v(k,j,i) + v(k,j,i-1) - gv
@@ -1877,7 +1905,7 @@
           DO  k = nzb+1, nzb_max
 
-             ibit11 = IBITS(advc_flags_1(k,j,i-1),11,1)
-             ibit10 = IBITS(advc_flags_1(k,j,i-1),10,1)
-             ibit9  = IBITS(advc_flags_1(k,j,i-1),9,1)
+             ibit11 = REAL( IBITS(advc_flags_1(k,j,i-1),11,1), KIND = wp )
+             ibit10 = REAL( IBITS(advc_flags_1(k,j,i-1),10,1), KIND = wp )
+             ibit9  = REAL( IBITS(advc_flags_1(k,j,i-1),9,1),  KIND = wp )
 
              u_comp_l         = u(k,j,i) + u(k,j,i-1) - gu
@@ -1929,8 +1957,4 @@
           
        ENDIF
-
-       flux_t(0) = 0.0_wp
-       diss_t(0) = 0.0_wp
-       w_comp(0) = 0.0_wp
 !
 !--    Now compute the fluxes tendency terms for the horizontal and
@@ -1938,7 +1962,7 @@
        DO  k = nzb+1, nzb_max
 
-          ibit11 = IBITS(advc_flags_1(k,j,i),11,1)
-          ibit10 = IBITS(advc_flags_1(k,j,i),10,1)
-          ibit9  = IBITS(advc_flags_1(k,j,i),9,1)
+          ibit11 = REAL( IBITS(advc_flags_1(k,j,i),11,1), KIND = wp )
+          ibit10 = REAL( IBITS(advc_flags_1(k,j,i),10,1), KIND = wp )
+          ibit9  = REAL( IBITS(advc_flags_1(k,j,i),9,1),  KIND = wp )
 
           u_comp(k) = u(k,j,i+1) + u(k,j,i)
@@ -1973,7 +1997,7 @@
                                                 )
 
-          ibit14 = IBITS(advc_flags_1(k,j,i),14,1)
-          ibit13 = IBITS(advc_flags_1(k,j,i),13,1)
-          ibit12 = IBITS(advc_flags_1(k,j,i),12,1)
+          ibit14 = REAL( IBITS(advc_flags_1(k,j,i),14,1), KIND = wp )
+          ibit13 = REAL( IBITS(advc_flags_1(k,j,i),13,1), KIND = wp )
+          ibit12 = REAL( IBITS(advc_flags_1(k,j,i),12,1), KIND = wp )
 
           v_comp(k) = v(k,j+1,i) + v(k,j+1,i-1) - gv
@@ -2007,10 +2031,48 @@
                                     ( u(k,j+3,i) - u(k,j-2,i) )               &
                                             )
+       ENDDO
+
+       DO  k = nzb_max+1, nzt
+
+          u_comp(k) = u(k,j,i+1) + u(k,j,i)
+          flux_r(k) = ( u_comp(k) - gu ) * (                                  &
+                         37.0_wp * ( u(k,j,i+1) + u(k,j,i)   )                &
+                       -  8.0_wp * ( u(k,j,i+2) + u(k,j,i-1) )                &
+                       +           ( u(k,j,i+3) + u(k,j,i-2) ) ) * adv_mom_5
+          diss_r(k) = - ABS( u_comp(k) - gu ) * (                             &
+                         10.0_wp * ( u(k,j,i+1) - u(k,j,i)   )                &
+                       -  5.0_wp * ( u(k,j,i+2) - u(k,j,i-1) )                &
+                       +           ( u(k,j,i+3) - u(k,j,i-2) ) ) * adv_mom_5
+
+          v_comp(k) = v(k,j+1,i) + v(k,j+1,i-1) - gv
+          flux_n(k) = v_comp(k) * (                                           &
+                         37.0_wp * ( u(k,j+1,i) + u(k,j,i)   )                &
+                       -  8.0_wp * ( u(k,j+2,i) + u(k,j-1,i) )                &
+                       +           ( u(k,j+3,i) + u(k,j-2,i) ) ) * adv_mom_5
+          diss_n(k) = - ABS( v_comp(k) ) * (                                  &
+                         10.0_wp * ( u(k,j+1,i) - u(k,j,i)   )                &
+                       -  5.0_wp * ( u(k,j+2,i) - u(k,j-1,i) )                &
+                       +           ( u(k,j+3,i) - u(k,j-2,i) ) ) * adv_mom_5
+
+       ENDDO
+!
+!--    Now, compute vertical fluxes. Split loop into a part treating the 
+!--    lowest 2 grid points with indirect indexing, a main loop without
+!--    indirect indexing, and a loop for the uppermost 2 grip points with
+!--    indirect indexing. This allows better vectorization for the main loop.
+!--    First, compute the flux at model surface, which need has to be 
+!--    calculated explicetely for the tendency at
+!--    the first w-level. For topography wall this is done implicitely by
+!--    advc_flags_1.
+       flux_t(nzb) = 0.0_wp
+       diss_t(nzb) = 0.0_wp
+       w_comp(nzb) = 0.0_wp
+       DO  k = nzb+1, nzb+2
 !
 !--       k index has to be modified near bottom and top, else array
 !--       subscripts will be exceeded.
-          ibit17 = IBITS(advc_flags_1(k,j,i),17,1)
-          ibit16 = IBITS(advc_flags_1(k,j,i),16,1)
-          ibit15 = IBITS(advc_flags_1(k,j,i),15,1)
+          ibit17 = REAL( IBITS(advc_flags_1(k,j,i),17,1), KIND = wp )
+          ibit16 = REAL( IBITS(advc_flags_1(k,j,i),16,1), KIND = wp )
+          ibit15 = REAL( IBITS(advc_flags_1(k,j,i),15,1), KIND = wp )
 
           k_ppp = k + 3 * ibit17
